StimEffect = UnitEffect:new()
StimEffect:addAction(function (unit,caster,skill)
	unit.buffs[Buff:new(caster.skills.stim.stimtime,{},function(unit,dt)
		unit.movementspeedbuffpercent = unit.movementspeedbuffpercent + caster.skills.stim.movementspeedbuffpercent
		unit.spellspeedbuffpercent = unit.spellspeedbuffpercent + caster.skills.stim.spellspeedbuffpercent
	end)]=true
end)
Stim = Skill:subclass('Stim')
function Stim:initialize(unit,level)
	level = level or 0
	super.initialize(self)
	self.unit = unit
	self.name = 'Stim'
	self.effecttime = -1
	self.effect = StimEffect
	self.cddt = 0
	self.cdtime = 30
	self.stimtime = 10
	self.available = true
	self:setLevel(level)
end

function Stim:cd(dt)
	self.cddt = self.cddt + dt
	if self.cddt > self.cdtime then
		self.available = true
	end
end

function Stim:active()
	if not self.available then
		return false,'Ability Cooldown'
	end
	if self.unit:getHPPercent()<0.2 then
		return false,'Not enough HP'
	end
	self.available = false
	self.unit:damage('Cost',self.unit:getHP()*0.2)
	self.effect:effect(self:geteffectinfo())
	return true
end

function Stim:getdescription()
	a='Stim\nUse vitality power to strength assassin for a short period of time. Lose HP to initiate. Cannot initiate if your HP if below 20%.\nFirerate:\nDamage:\nCurrent Level:'
	return a
end

function Stim:getdescriptiondata()
	return '\n\n'..string.format('%.1f',1/self.casttime)..' shots per second\n'..self.damage..' points\n'..self.level
end

function Stim:geteffectinfo()
	return self.unit,self.unit,self
end

function Stim:stop()
	self.time = 0
end

function Stim:setLevel(lvl)
	self.movementspeedbuffpercent = 0.5*lvl -- inversely proportional
	self.spellspeedbuffpercent = 0.5*lvl
	self.level = lvl
end
