BulletEffect = UnitEffect:new()
BulletEffect:addAction(function (unit,caster,skill)
	unit:damage('Bullet',skill.damage,caster)
end)
explosiveBulletEffect = CircleAoEEffect:new(50)
--explosiveBulletEffect:addAction(getExplosionAction(100,nil,function(unit)return not unit:isKindOf(Missle) end))
StunBulletEffect = UnitEffect:new()
StunBulletEffect:addAction(function (unit,caster,skill,missle)
	unit:damage('Bullet',skill.damage,caster.unit)
	--print (caster.x)
	if math.random()< caster.unit.skills.stunbullet.stunchance then
		unit.buffs[Buff:new(0.5,StunBehaviorTable)]=true
	end
	if math.random()< caster.unit.skills.explosivebullet.explosivechance then
		explosiveBulletEffect:effect({caster.x,caster.y},caster,skill)
	end
end)

PistolEffect = ShootMissleEffect:new()
PistolEffect:addAction(function(point,caster,skill)
	local missle = skill.bullettype:new(2,1,1000,caster.x,caster.y,unpack(point))
	missle.controller = 'playermissle'
	missle.effect = skill.bulleteffect
	missle.skill = skill
	missle.unit = caster
	map:addUnit(missle)
end)

Pistol = Skill:subclass('Pistol')
function Pistol:initialize(unit,level)
	level = level or 0
	super.initialize(self)
	self.unit = unit
	self.bullettype = Bullet
	self.name = 'Pistol'
	self.effecttime = 0.1
	self.damage = 50
	self.effect = PistolEffect
	self.bulleteffect = StunBulletEffect
	self.bullettype = Bullet
	self:setLevel(level)
end

function Pistol:getdescription()
	a='Pistol\nHand Made. Purely awesome.\nFirerate:\nDamage:\nCurrent Level:'
	return a
end

function Pistol:getdescriptiondata()
	return '\n\n'..string.format('%.1f',1/self.casttime)..' shots per second\n'..self.damage..' points\n'..self.level
end

function Pistol:geteffectinfo()
	return self.direction,self.unit,self
end

function Pistol:stop()
	self.time = 0
end

function Pistol:setLevel(lvl)
	self.casttime = 0.7/(1+lvl*0.2) -- inversely proportional
	self.level = lvl
	if lvl == 2 then
		if self.unit.skills.stunbullet then
			return {self.unit.skills.stunbullet}
		end
	elseif lvl == 4 then
		if self.unit.skills.explosivebullet then
			return {self.unit.skills.explosivebullet}
		end
	elseif lvl == 6 then
		if self.unit.skills.momentumbullet then
			return {self.unit.skills.momentumbullet}
		end
	end
end

StunBullet = Skill:subclass('StunBullet')
function StunBullet:initialize(unit,level)
	level = level or -1
	super.initialize(self)
	self.unit = unit
	self.name = 'StunBullet'
	self:setLevel(level)
	self.stunchance = 0
end

function StunBullet:setLevel(lvl)
	self.stunchance = 0.1+0.04*lvl
	self.level = lvl
end

function StunBullet:getdescription()
	a='Stun Bullet\nAssassin inject mindpower into his bullets, chance to stun enemy.(Dispellsable)\nChance:\nCurrent Level:'
	return a
end

function StunBullet:getdescriptiondata()
	return '\n\n\n'..string.format('%.1f',self.stunchance*100)..' % chance to stun enemy\n'..self.level
end

ExplosiveBullet = Skill:subclass('ExplosiveBullet')
function ExplosiveBullet:initialize(unit,level)
	level = level or -1
	super.initialize(self)
	self.unit = unit
	self.name = 'ExplosiveBullet'
	self:setLevel(level)
	self.explosivechance = 0
	self.impactforce = 0
end
function ExplosiveBullet:setLevel(lvl)
	if lvl>0 then
		self.explosivechance = 0.1+0.04*lvl
		self.impactforce = 30+lvl*10
		explosiveBulletEffect.actions={}
		explosiveBulletEffect:addAction(getExplosionAction(self.impactforce,nil,function(unit)return not unit:isKindOf(Missle) end))
	end
	self.level = lvl
end

function ExplosiveBullet:getdescription()
	a='Explosive Bullet\nAssassin tweaks his ammo, make them possible to create a small area impact in target area.(massive units are unaffected)\nChance:\nImpact Force:\nCurrent Level:'
	return a
end

function ExplosiveBullet:getdescriptiondata()
	return '\n\n\n'..string.format('%.1f',self.explosivechance*100)..' % chance to stun enemy\n'..self.impactforce..' Impact force\n'..self.level
end

AbsoluteMomentum = Skill:subclass('AbsoluteMomentum')

function AbsoluteMomentum:initialize(unit,level)
	level = level or -1
	super.initialize(self)
	self.unit = unit
	self.name = 'MomentumBullet'
	self:setLevel(level)
end

function AbsoluteMomentum:setLevel(lvl)
	if lvl>0 then
		self.unit.skills.pistol.bullettype = MomentumBullet
	end
	self.level = lvl
end


function AbsoluteMomentum:getdescription()
	--a='Explosive Bullet\nAssassin tweaks his ammo, make them possible to create a small area impact in target area.(massive units are unaffected)\nChance:\nImpact Force:\nCurrent Level:'
	return 'Absolute Momentum\nEvery bullet you fire will possess absolute momentum, penetrating your enemies unstopping.'
end

function AbsoluteMomentum:getdescriptiondata()
	return ''
	--return '\n\n\n'..string.format('%.1f',self.explosivechance*100)..' % chance to stun enemy\n'..self.impactforce..' Impact force\n'..self.level
end