Skill = Object:subclass('Skill')
function Skill:initialize()
	self.time = 0
	self.effecttime = 0.1
	self.casttime = 0.3
	self.effected = false
end

function Skill:getLevel()
	if self.level then return self.level end
end

function Skill:update(dt)
	if self.effecttime < 0 then return end
	self.time = dt + self.time
	if self.time >= self.effecttime and not self.effected then
		--print (self.effect.effect)
		if self.effect then self.effect:effect(self:geteffectinfo()) end
		self.effected = true
	end
	if self.time >= self.casttime then
		self.effected = false
		if self.stop then self:stop() end
	end
end


Melee = Skill:subclass('Melee')

function Melee:initialize()
	super.initialize(self)
	self.effecttime = 0.05
end

function Melee:effect()
	local angle = math.atan2(self.direction[2],self.direction[1])
	units = map:findUnitsWithCondition(
		function(unit) 
			return unit~=self.unit and withinfanarea(unit,self.unit.x,self.unit.y,100,angle,math.pi/4)
		end)
	for k,unit in pairs(units) do
		if unit.state == 'slide' then
			unit.body:applyImpulse((unit.x-self.unit.x),(unit.y-self.unit.y))
		end
		
		if unit.damage then unit:damage('melee',100) end
	end
end

function Melee:stop()
	self.time = 0
end
