require ('objectlua')
Object = objectlua.Object
require ('libraries/camera.lua')
require ('libraries/scene.lua')
require ('libraries/unit.lua')
require ('libraries/skill.lua')
require ('libraries/skilleffect.lua')
require ('libraries/missle.lua')
require ('libraries/button.lua')
require ('libraries/particles.lua')
require ('libraries/buff.lua')
require ('libraries/system.lua')
require ('libraries/hud.lua')
require ('units/init.lua')
require ('abilities/init.lua')

gamesystems = {}
function pushsystem(system)
	table.insert(gamesystems,system)
	currentsystem = system
end

function popsystem()
	local sys = table.remove(gamesystems)
	currentsystem = gamesystems[#gamesystems]
	return sys
end

function pause(state)
	pausing = state
end


function love.load()
	require ('tests/testassests.lua')
	local f=love.graphics.newFont("awesome.ttf",20)
	love.graphics.setFont(f)
end


progressed = 0
steptime = 1/60

function love.update(dt)
	if pausing then return end
	
	progressed = progressed + dt
	if progressed>steptime then
		currentsystem:update(steptime)
		progressed = progressed - steptime
	end
end

function love.draw()
	currentsystem:draw()
end

