testbackground = {}
love.graphics.setBackgroundColor(200,200,200,255)
local bg = love.graphics.newFramebuffer(2000,2000)
love.graphics.setRenderTarget(bg)
love.graphics.setLineWidth(3)
for i = 1,50 do
	local n = i*40
	love.graphics.line(n,0,n,2000)
	love.graphics.line(0,n,2000,n)
end
love.graphics.setRenderTarget()
function testbackground:draw()
	love.graphics.draw(bg,-1000,-1000)
end
map = Map:new(2000,2000)
map.background = testbackground
t = Assassin:new(600,600,32,10)
t.controller = 'player'
t2 = Unit:new(400,600,32,10)
t2.countroller = 'enemy'
map:addUnit(t,t2)
for i = 1,20 do
	local angle = math.pi/10*i
	local b = Box:new(300+100*math.cos(angle),300+100*math.sin(angle))
	b.controller = 'enemy'
	map:addUnit(b)
end

map.camera = FollowerCamera:new(t)
game = {}
melee = Melee:new()
melee.unit = t
shifts = {a={-1,0},
	d={1,0},
	w={0,-1},
	s={0,1}}

hpbar = AssassinHPBar:new(function() return 0.5 end,30,30,200)
trail = Trail:new(30,42,{{0,0},{40,0},{45,-12},{55,12},{60,0},{100,0}},50,2,1)
function game:update(dt)
	if love.mouse.isDown('l') then
		local x,y = love.mouse.getPosition()
		x,y=x-400,y-300
		local n=math.sqrt(x*x+y*y)
		x,y=x/n,y/n
		t.skill = t.skills.pistol
		t.skill.direction = {x,y}
	
	else
		t.skill = nil
	end	
	if love.mouse.isDown('r') then
		print(t.skills.stim:active())
	end
	local walk = false
	
		local x,y = 0,0
	for k,v in pairs(shifts) do
		if love.keyboard.isDown(k) then
			walk = true
			x,y=x+v[1],y+v[2]
		end
	end
	local n=math.sqrt(x*x+y*y)
	x,y=x/n,y/n
	t.direction = {x,y}
	t.state = 'move'
	if not walk then
		t.state = 'stop'
	end
end

tree = AssassinAbiTree:new(t)

function love.keypressed(k)
	if k == 't' then
		if currentsystem == tree then
			tree:fold()
		else
			tree:show()
			pushsystem(tree)
		end
	elseif k == 'u' then
		t.buffs[b_Stun:new(3,true)] = true
	end
end


demosystem = {}
function demosystem:update(dt)
		game:update(dt)
		map:update(dt)
		trail:update(dt)
end

function demosystem:draw()
	map:draw()
	map.camera:revert()
	hpbar:draw()
	trail:draw()
end

pushsystem(demosystem)