Box = Unit:subclass('Box')
local boxpic = love.graphics.newImage('box.png')
deadquad = love.graphics.newQuad(0,0,32,8,32,32)
function Box:initialize(x,y)
	super.initialize(self,x,y,16,10)
	self.HP = 100
	self.state = 'slide'
end

function Box:damage(type,amount,source)
	self.HP = self.HP - amount
	if self.HP <= 0 then self:kill() end
end

function Box:draw()
	love.graphics.draw(boxpic,self.x,self.y,self.body:getAngle(),1,1,16,16)
end

function Box:kill()
self.shape:setMask(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)
--	self.body:setPosition(unpack(safezone))
--	self.shape:destroy()
	self.body:destroy()
	map:addUnit(BoxDead:new(self.x,self.y))
--	self.body:setActive(false)
	map:removeUnit(self)
end

BoxDead = Unit:subclass('BoxDead')
function BoxDead:initialize(x,y)
	self.x,self.y = x,y
	self.time = 3
	self.bodies = {}
	self.shape = {}
	self.dt = 0
end

function BoxDead:update(dt)
	self.dt = self.dt + dt
	if self.dt> self.time then
--		for k,unit in ipairs(self.bodies) do unit:setPosition(unpack(safezone)) end
--		for k,unit in ipairs(self.shape) do unit:destroy() end
--			for k,unit in ipairs(self.bodies) do unit:destroy() end
		map:removeUnit(self)
	end
end

function BoxDead:createBody(world)
	for i=1,4 do
		local x,y = self.x+math.random(-30,30),self.y+math.random(-30,30)
		local b = love.physics.newBody(world,x,y,5,5)
		local s = love.physics.newRectangleShape(b,0,0,32,8)
		b:setAngle(math.random()*math.pi)
		b:applyImpulse((x-self.x)/10,(y-self.y)/10)
		category,masks = unpack(typeinfo['dead'])
		s:setCategory(category)
		s:setMask(unpack(masks))
		table.insert(self.bodies,b)
		table.insert(self.shape,s)
	end
end

function BoxDead:draw()
	for k,unit in ipairs(self.bodies) do
		love.graphics.drawq(boxpic,deadquad,unit:getX(),unit:getY(),unit:getAngle(),1,1,16,4)
	end
end